Index: channels/chan_agent.c
===================================================================
--- channels/chan_agent.c	(revision 8431)
+++ channels/chan_agent.c	(working copy)
@@ -2494,8 +2494,11 @@
 
 static char *function_agent(struct ast_channel *chan, char *cmd, char *data, char *buf, size_t len)
 {
-	char *agentid;
-	char *item;
+	char *parse;    
+	AST_DECLARE_APP_ARGS(args,
+		AST_APP_ARG(agentid);
+		AST_APP_ARG(item);
+	);
 	char *tmp;
 	struct agent_pvt *agent;
 
@@ -2506,39 +2509,39 @@
 		return buf;	
 	}
 
-	if (!(item = ast_strdupa(data)))
+	if (!(parse = ast_strdupa(data)))
 		return buf;
 
-	agentid	= strsep(&item, ":");
-	if (!item)
-		item = "status";
+	AST_NONSTANDARD_APP_ARGS(args, parse, ':');
+	if(!args.item)
+		args.item = "status";
 
-	agent = find_agent(agentid);
+	agent = find_agent(args.agentid);
 	if (!agent) {
-		ast_log(LOG_WARNING, "Agent '%s' not found!\n", agentid);
+		ast_log(LOG_WARNING, "Agent '%s' not found!\n", args.agentid);
 		return buf;
 	}
 
-	if (!strcasecmp(item, "status")) {
+	if (!strcasecmp(args.item, "status")) {
 		if (agent->chan || !ast_strlen_zero(agent->loginchan)) {
 			ast_copy_string(buf, "LOGGEDIN", len);
 		} else {
 			ast_copy_string(buf, "LOGGEDOUT", len);
 		}
-	} else if (!strcasecmp(item, "password")) {
+	} else if (!strcasecmp(args.item, "password")) {
 		ast_copy_string(buf, agent->password, len);
-	} else if (!strcasecmp(item, "name")) {
+	} else if (!strcasecmp(args.item, "name")) {
 		ast_copy_string(buf, agent->name, len);
-	} else if (!strcasecmp(item, "mohclass")) {
+	} else if (!strcasecmp(args.item, "mohclass")) {
 		ast_copy_string(buf, agent->moh, len);
-	} else if (!strcasecmp(item, "channel")) {
+	} else if (!strcasecmp(args.item, "channel")) {
 		if (agent->chan) {
 			ast_copy_string(buf, agent->chan->name, len);
 			tmp = strrchr(buf, '-');
 			if (tmp)
 				*tmp = '\0';
 		} 
-	} else if (!strcasecmp(item, "exten")) {
+	} else if (!strcasecmp(args.item, "exten")) {
 		ast_copy_string(buf, agent->loginchan, len);	
 	}
 
